﻿------------------------------------------------------------------------------------------
--Monk Chi--------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
local SN, L, F, T, M, _ = unpack(select(2,...))
local LSM = LibStub("LibSharedMedia-3.0")
local CP = SN:GetModule("classResources")

local unpack = unpack
local collectgarbage = collectgarbage
local SPELL_POWER_CHI = SPELL_POWER_CHI
local UnitPower = UnitPower
local UnitPowerMax = UnitPowerMax

function CP:SetupChi()
	if SN.playerClass ~= "MONK" then return end
	local frame = F.classpower
	local color = M.classResources.MONK
	local maxChi = SN['classMaxResourceBar']["MONK"]

	frame.chi = CP:PowerBubbles(maxChi)
	for i = 1, maxChi do
		frame.chi[i]:SetStatusBarColor(unpack(color[i]))
	end

	frame.chi:SetScript("OnEvent", function(self, event, ...)

		if event == "UNIT_POWER" or event == "UNIT_DISPLAYPOWER" then
			CP:ChiPoints(self)
		end
	end)
	frame.chi:Hide()
end

function CP:ChiEnable()
	local frame = F.classpower
	frame.chi:Show()
	frame.chi:RegisterEvent("UNIT_POWER")
	frame.chi:RegisterEvent("UNIT_DISPLAYPOWER")
	frame.chi:RegisterEvent("PLAYER_LEVEL_UP")	
	MonkHarmonyBar:Hide()
	MonkHarmonyBar:UnregisterAllEvents()
	CP:ChiPoints(frame.chi)
	collectgarbage("collect")
end

function CP:ChiDisable()
	local frame = F.classpower
	frame.chi:UnregisterAllEvents()
	frame.chi:Hide()
	if not MonkHarmonyBar:IsVisible() then
		MonkHarmonyBar:Show()
		MonkHarmonyBar:GetScript("OnLoad")(MonkHarmonyBar)
	end
	collectgarbage("collect")
end

function CP:ChiPoints(self)
	local light = UnitPower("player", SPELL_POWER_CHI)
	local numPoints = UnitPowerMax("player", SPELL_POWER_CHI)

	for i = 1, numPoints do
		if i <= light then
			self[i]:SetAlpha(1)
		else
			self[i]:SetAlpha(0.1)
		end
		self[i]:SetSize((SN.data.profile.classResources.width - (numPoints + 1) * 3) / numPoints, SN.data.profile.classResources.height - 6)
		self[i]:Show()
		if numPoints < self.maxbub then
			self[self.maxbub]:Hide()
		end
	end
end